Azure OpenAI conversations

API Version: v1

Server: {endpoint}/openai/v1 — Azure AI Foundry Models APIs

Server Variables:

Variable Default Description
endpoint A supported Azure AI Foundry Models APIs endpoint, including protocol and hostname.
For example:
https://YOUR-RESOURCE-NAME.openai.azure.com/openai/v1/).

Authentication

ApiKeyAuth (API Key)

Pass your API key in the api-key header.

ApiKeyAuth_ (API Key)

Pass your API key in the authorization header.

OAuth2Auth (OAuth 2.0)

Flow: implicit

Authorization URL: https://login.microsoftonline.com/common/oauth2/v2.0/authorize

Scopes:

  • https://cognitiveservices.azure.com/.default

Security Requirements

Endpoints accept any one of the following authentication methods:

  1. ApiKeyAuth
  2. ApiKeyAuth_
  3. OAuth2Auth (scopes: https://cognitiveservices.azure.com/.default)

Create conversation

POST {endpoint}/openai/v1/conversations

URI Parameters

Name In Required Type Description
endpoint server Yes string A supported Azure AI Foundry Models APIs endpoint, including protocol and hostname.
For example:
https://YOUR-RESOURCE-NAME.openai.azure.com/openai/v1/).
api-version query No string
Possible values: v1, preview
The explicit Azure AI Foundry Models API version to use for this request.
v1 if not otherwise specified.

Request Body

Content-Type: application/json

Name Type Description Required Default
items array of OpenAI.InputItem or null No
metadata OpenAI.Metadata or null No

Responses

Status Code: 200

Description: The request has succeeded.

Content-Type Type Description
application/json OpenAI.ConversationResource

Response Headers:

Header Type Description
apim-request-id string A request ID used for troubleshooting purposes.

Status Code: default

Description: An unexpected error response.

Content-Type Type Description
application/json object
Name Type Description Required Default
code string or null Yes
inner_error No
message string Yes
param string or null No
type string No

Response Headers:

Header Type Description
apim-request-id string A request ID used for troubleshooting purposes.

Retrieve conversation

GET {endpoint}/openai/v1/conversations/{conversation_id}

URI Parameters

Name In Required Type Description
endpoint server Yes string A supported Azure AI Foundry Models APIs endpoint, including protocol and hostname.
For example:
https://YOUR-RESOURCE-NAME.openai.azure.com/openai/v1/).
api-version query No string
Possible values: v1, preview
The explicit Azure AI Foundry Models API version to use for this request.
v1 if not otherwise specified.
conversation_id path Yes string The ID of the conversation to retrieve.

Responses

Status Code: 200

Description: The request has succeeded.

Content-Type Type Description
application/json OpenAI.ConversationResource

Response Headers:

Header Type Description
apim-request-id string A request ID used for troubleshooting purposes.

Status Code: default

Description: An unexpected error response.

Content-Type Type Description
application/json object
Name Type Description Required Default
code string or null Yes
inner_error No
message string Yes
param string or null No
type string No

Response Headers:

Header Type Description
apim-request-id string A request ID used for troubleshooting purposes.

Update conversation

POST {endpoint}/openai/v1/conversations/{conversation_id}

URI Parameters

Name In Required Type Description
endpoint server Yes string A supported Azure AI Foundry Models APIs endpoint, including protocol and hostname.
For example:
https://YOUR-RESOURCE-NAME.openai.azure.com/openai/v1/).
api-version query No string
Possible values: v1, preview
The explicit Azure AI Foundry Models API version to use for this request.
v1 if not otherwise specified.
conversation_id path Yes string The ID of the conversation to update.

Request Body

Content-Type: application/json

Name Type Description Required Default
metadata OpenAI.Metadata or null Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard.
Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.
Yes

Responses

Status Code: 200

Description: The request has succeeded.

Content-Type Type Description
application/json OpenAI.ConversationResource

Response Headers:

Header Type Description
apim-request-id string A request ID used for troubleshooting purposes.

Status Code: default

Description: An unexpected error response.

Content-Type Type Description
application/json object
Name Type Description Required Default
code string or null Yes
inner_error No
message string Yes
param string or null No
type string No

Response Headers:

Header Type Description
apim-request-id string A request ID used for troubleshooting purposes.

Delete conversation

DELETE {endpoint}/openai/v1/conversations/{conversation_id}

URI Parameters

Name In Required Type Description
endpoint server Yes string A supported Azure AI Foundry Models APIs endpoint, including protocol and hostname.
For example:
https://YOUR-RESOURCE-NAME.openai.azure.com/openai/v1/).
api-version query No string
Possible values: v1, preview
The explicit Azure AI Foundry Models API version to use for this request.
v1 if not otherwise specified.
conversation_id path Yes string The ID of the conversation to delete.

Responses

Status Code: 200

Description: The request has succeeded.

Content-Type Type Description
application/json OpenAI.DeletedConversationResource

Response Headers:

Header Type Description
apim-request-id string A request ID used for troubleshooting purposes.

Status Code: default

Description: An unexpected error response.

Content-Type Type Description
application/json object
Name Type Description Required Default
code string or null Yes
inner_error No
message string Yes
param string or null No
type string No

Response Headers:

Header Type Description
apim-request-id string A request ID used for troubleshooting purposes.

List conversation items

GET {endpoint}/openai/v1/conversations/{conversation_id}/items

URI Parameters

Name In Required Type Description
endpoint server Yes string A supported Azure AI Foundry Models APIs endpoint, including protocol and hostname.
For example:
https://YOUR-RESOURCE-NAME.openai.azure.com/openai/v1/).
api-version query No string
Possible values: v1, preview
The explicit Azure AI Foundry Models API version to use for this request.
v1 if not otherwise specified.
conversation_id path Yes string The ID of the conversation to list items for.
limit query No integer (int32) A limit on the number of objects to be returned. Limit can range between 1 and 100, and the default is 20.
Serialization: explode: false
order query No string
Possible values: asc, desc
The order to return the input items in. Default is desc.
Serialization: explode: false
after query No string An item ID to list items after, used in pagination.
Serialization: explode: false
include query No array Specify additional output data to include in the model response.
Serialization: explode: false

Responses

Status Code: 200

Description: The request has succeeded.

Content-Type Type Description
application/json OpenAI.ConversationItemList

Response Headers:

Header Type Description
apim-request-id string A request ID used for troubleshooting purposes.

Status Code: default

Description: An unexpected error response.

Content-Type Type Description
application/json object
Name Type Description Required Default
code string or null Yes
inner_error No
message string Yes
param string or null No
type string No

Response Headers:

Header Type Description
apim-request-id string A request ID used for troubleshooting purposes.

Create conversation items

POST {endpoint}/openai/v1/conversations/{conversation_id}/items

URI Parameters

Name In Required Type Description
endpoint server Yes string A supported Azure AI Foundry Models APIs endpoint, including protocol and hostname.
For example:
https://YOUR-RESOURCE-NAME.openai.azure.com/openai/v1/).
api-version query No string
Possible values: v1, preview
The explicit Azure AI Foundry Models API version to use for this request.
v1 if not otherwise specified.
conversation_id path Yes string The ID of the conversation to add the item to.
include query No array Additional fields to include in the response.
Serialization: explode: false

Request Body

Content-Type: application/json

Name Type Description Required Default
items array of OpenAI.InputItem Constraints: maxItems: 20 Yes

Responses

Status Code: 200

Description: The request has succeeded.

Content-Type Type Description
application/json OpenAI.ConversationItemList

Response Headers:

Header Type Description
apim-request-id string A request ID used for troubleshooting purposes.

Status Code: default

Description: An unexpected error response.

Content-Type Type Description
application/json object
Name Type Description Required Default
code string or null Yes
inner_error No
message string Yes
param string or null No
type string No

Response Headers:

Header Type Description
apim-request-id string A request ID used for troubleshooting purposes.

Retrieve conversation item

GET {endpoint}/openai/v1/conversations/{conversation_id}/items/{item_id}

URI Parameters

Name In Required Type Description
endpoint server Yes string A supported Azure AI Foundry Models APIs endpoint, including protocol and hostname.
For example:
https://YOUR-RESOURCE-NAME.openai.azure.com/openai/v1/).
api-version query No string
Possible values: v1, preview
The explicit Azure AI Foundry Models API version to use for this request.
v1 if not otherwise specified.
conversation_id path Yes string The ID of the conversation that contains the item.
item_id path Yes string The ID of the item to retrieve.
include query No array Additional fields to include in the response.
Serialization: explode: false

Responses

Status Code: 200

Description: The request has succeeded.

Content-Type Type Description
application/json OpenAI.ConversationItem

Response Headers:

Header Type Description
apim-request-id string A request ID used for troubleshooting purposes.

Status Code: default

Description: An unexpected error response.

Content-Type Type Description
application/json object
Name Type Description Required Default
code string or null Yes
inner_error No
message string Yes
param string or null No
type string No

Response Headers:

Header Type Description
apim-request-id string A request ID used for troubleshooting purposes.

Delete conversation item

DELETE {endpoint}/openai/v1/conversations/{conversation_id}/items/{item_id}

URI Parameters

Name In Required Type Description
endpoint server Yes string A supported Azure AI Foundry Models APIs endpoint, including protocol and hostname.
For example:
https://YOUR-RESOURCE-NAME.openai.azure.com/openai/v1/).
api-version query No string
Possible values: v1, preview
The explicit Azure AI Foundry Models API version to use for this request.
v1 if not otherwise specified.
conversation_id path Yes string The ID of the conversation that contains the item.
item_id path Yes string The ID of the item to delete.

Responses

Status Code: 200

Description: The request has succeeded.

Content-Type Type Description
application/json OpenAI.ConversationResource

Response Headers:

Header Type Description
apim-request-id string A request ID used for troubleshooting purposes.

Status Code: default

Description: An unexpected error response.

Content-Type Type Description
application/json object
Name Type Description Required Default
code string or null Yes
inner_error No
message string Yes
param string or null No
type string No

Response Headers:

Header Type Description
apim-request-id string A request ID used for troubleshooting purposes.

Components

AzureAIFoundryModelsApiVersion

Property Value
Type string
Values v1
preview

AzureToolApprovalResponse

Azure tool approval response

An Azure tool approval response in the request input.

Name Type Description Required Default
approval_request_id string The ID of the approval request being answered. Yes
approve boolean Whether the request was approved. Yes
type enum The type of the item. Always tool_approval_response.
Possible values: tool_approval_response
Yes

OpenAI.Annotation

An annotation that applies to a span of output text.

Discriminator for OpenAI.Annotation

This component uses the property type to discriminate between different types:

Type Value Schema
file_citation OpenAI.FileCitationBody
url_citation OpenAI.UrlCitationBody
container_file_citation OpenAI.ContainerFileCitationBody
file_path OpenAI.FilePath
Name Type Description Required Default
type OpenAI.AnnotationType Yes

OpenAI.AnnotationType

Property Value
Type string
Values file_citation
url_citation
container_file_citation
file_path

OpenAI.ApplyPatchCallOutputStatus

Property Value
Type string
Values completed
failed

OpenAI.ApplyPatchCallOutputStatusParam

Apply patch call output status

Outcome values reported for apply_patch tool call outputs.

Property Value
Type string
Values completed
failed

OpenAI.ApplyPatchCallStatus

Property Value
Type string
Values in_progress
completed

OpenAI.ApplyPatchCallStatusParam

Apply patch call status

Status values reported for apply_patch tool calls.

Property Value
Type string
Values in_progress
completed

OpenAI.ApplyPatchCreateFileOperation

Apply patch create file operation

Instruction describing how to create a file via the apply_patch tool.

Name Type Description Required Default
diff string Diff to apply. Yes
path string Path of the file to create. Yes
type enum Create a new file with the provided diff.
Possible values: create_file
Yes create_file

OpenAI.ApplyPatchCreateFileOperationParam

Apply patch create file operation

Instruction for creating a new file via the apply_patch tool.

Name Type Description Required Default
diff string Unified diff content to apply when creating the file.
Constraints: maxLength: 10485760
Yes
path string Path of the file to create relative to the workspace root.
Constraints: minLength: 1
Yes
type enum The operation type. Always create_file.
Possible values: create_file
Yes create_file

OpenAI.ApplyPatchDeleteFileOperation

Apply patch delete file operation

Instruction describing how to delete a file via the apply_patch tool.

Name Type Description Required Default
path string Path of the file to delete. Yes
type enum Delete the specified file.
Possible values: delete_file
Yes delete_file

OpenAI.ApplyPatchDeleteFileOperationParam

Apply patch delete file operation

Instruction for deleting an existing file via the apply_patch tool.

Name Type Description Required Default
path string Path of the file to delete relative to the workspace root.
Constraints: minLength: 1
Yes
type enum The operation type. Always delete_file.
Possible values: delete_file
Yes delete_file

OpenAI.ApplyPatchFileOperation

Apply patch operation

One of the create_file, delete_file, or update_file operations applied via apply_patch.

Discriminator for OpenAI.ApplyPatchFileOperation

This component uses the property type to discriminate between different types:

Type Value Schema
create_file OpenAI.ApplyPatchCreateFileOperation
delete_file OpenAI.ApplyPatchDeleteFileOperation
update_file OpenAI.ApplyPatchUpdateFileOperation
Name Type Description Required Default
type OpenAI.ApplyPatchFileOperationType Yes

OpenAI.ApplyPatchFileOperationType

Property Value
Type string
Values create_file
delete_file
update_file

OpenAI.ApplyPatchOperationParam

Apply patch operation

One of the create_file, delete_file, or update_file operations supplied to the apply_patch tool.

Discriminator for OpenAI.ApplyPatchOperationParam

This component uses the property type to discriminate between different types:

Type Value Schema
create_file OpenAI.ApplyPatchCreateFileOperationParam
delete_file OpenAI.ApplyPatchDeleteFileOperationParam
update_file OpenAI.ApplyPatchUpdateFileOperationParam
Name Type Description Required Default
type OpenAI.ApplyPatchOperationParamType Yes

OpenAI.ApplyPatchOperationParamType

Property Value
Type string
Values create_file
delete_file
update_file

OpenAI.ApplyPatchToolParam

Apply patch tool

Allows the assistant to create, delete, or update files using unified diffs.

Name Type Description Required Default
type enum The type of the tool. Always apply_patch.
Possible values: apply_patch
Yes apply_patch

OpenAI.ApplyPatchUpdateFileOperation

Apply patch update file operation

Instruction describing how to update a file via the apply_patch tool.

Name Type Description Required Default
diff string Diff to apply. Yes
path string Path of the file to update. Yes
type enum Update an existing file with the provided diff.
Possible values: update_file
Yes update_file

OpenAI.ApplyPatchUpdateFileOperationParam

Apply patch update file operation

Instruction for updating an existing file via the apply_patch tool.

Name Type Description Required Default
diff string Unified diff content to apply to the existing file.
Constraints: maxLength: 10485760
Yes
path string Path of the file to update relative to the workspace root.
Constraints: minLength: 1
Yes
type enum The operation type. Always update_file.
Possible values: update_file
Yes update_file

OpenAI.ApproximateLocation

Name Type Description Required Default
city string or null No
country string or null No
region string or null No
timezone string or null No
type enum The type of location approximation. Always approximate.
Possible values: approximate
Yes approximate

OpenAI.AutoCodeInterpreterToolParam

Automatic Code Interpreter Tool Parameters

Configuration for a code interpreter container. Optionally specify the IDs of the files to run the code on.

Name Type Description Required Default
file_ids array of string An optional list of uploaded files to make available to your code.
Constraints: maxItems: 50
No
memory_limit OpenAI.ContainerMemoryLimit or null No
network_policy OpenAI.ContainerNetworkPolicyParam Network access policy for the container. No
type enum Always auto.
Possible values: auto
Yes auto

OpenAI.ClickButtonType

Property Value
Type string
Values left
right
wheel
back
forward

OpenAI.ClickParam

Click

A click action.

Name Type Description Required Default
button OpenAI.ClickButtonType Yes
keys array of string or null No
type enum Specifies the event type. For a click action, this property is always click.
Possible values: click
Yes click
x integer The x-coordinate where the click occurred. Yes
y integer The y-coordinate where the click occurred. Yes

OpenAI.CodeInterpreterOutputImage

Code interpreter output image

The image output from the code interpreter.

Name Type Description Required Default
type enum The type of the output. Always image.
Possible values: image
Yes image
url string (uri) The URL of the image output from the code interpreter. Yes

OpenAI.CodeInterpreterOutputLogs

Code interpreter output logs

The logs output from the code interpreter.

Name Type Description Required Default
logs string The logs output from the code interpreter. Yes
type enum The type of the output. Always logs.
Possible values: logs
Yes logs

OpenAI.CodeInterpreterTool

Code interpreter

A tool that runs Python code to help generate a response to a prompt.

Name Type Description Required Default
container string or OpenAI.AutoCodeInterpreterToolParam The code interpreter container. Can be a container ID or an object that
specifies uploaded file IDs to make available to your code, along with an
optional memory_limit setting.
Yes
type enum The type of the code interpreter tool. Always code_interpreter.
Possible values: code_interpreter
Yes

OpenAI.ComparisonFilter

Comparison Filter

A filter used to compare a specified attribute key to a given value using a defined comparison operation.

Name Type Description Required Default
key string The key to compare against the value. Yes
type enum Specifies the comparison operator: eq, ne, gt, gte, lt, lte, in, nin.
- eq: equals
- ne: not equal
- gt: greater than
- gte: greater than or equal
- lt: less than
- lte: less than or equal
- in: in
- nin: not in
Possible values: eq, ne, gt, gte, lt, lte, in, nin
Yes eq
value string or number or boolean or array of string or number The value to compare against the attribute key; supports string, number, or boolean types. Yes

OpenAI.CompoundFilter

Compound Filter

Combine multiple filters using and or or.

Name Type Description Required Default
filters array of OpenAI.ComparisonFilter or object Array of filters to combine. Items can be ComparisonFilter or CompoundFilter. Yes
type enum Type of operation: and or or.
Possible values: and, or
Yes

OpenAI.ComputerAction

Discriminator for OpenAI.ComputerAction

This component uses the property type to discriminate between different types:

Type Value Schema
click OpenAI.ClickParam
double_click OpenAI.DoubleClickAction
drag OpenAI.DragParam
keypress OpenAI.KeyPressAction
move OpenAI.MoveParam
screenshot OpenAI.ScreenshotParam
scroll OpenAI.ScrollParam
type OpenAI.TypeParam
wait OpenAI.WaitParam
Name Type Description Required Default
type OpenAI.ComputerActionType Yes

OpenAI.ComputerActionList

Computer Action List

Flattened batched actions for computer_use. Each action includes an type discriminator and action-specific fields.

Array of: OpenAI.ComputerAction

OpenAI.ComputerActionType

Property Value
Type string
Values click
double_click
drag
keypress
move
screenshot
scroll
type
wait

OpenAI.ComputerCallSafetyCheckParam

A pending safety check for the computer call.

Name Type Description Required Default
code string or null No
id string The ID of the pending safety check. Yes
message string or null No

OpenAI.ComputerEnvironment

Property Value
Type string
Values windows
mac
linux
ubuntu
browser

OpenAI.ComputerScreenshotContent

Computer screenshot

A screenshot of a computer.

Name Type Description Required Default
detail OpenAI.ImageDetail Yes
file_id string or null Yes
image_url string or null Yes
type enum Specifies the event type. For a computer screenshot, this property is always set to computer_screenshot.
Possible values: computer_screenshot
Yes computer_screenshot

OpenAI.ComputerScreenshotImage

A computer screenshot image used with the computer use tool.

Name Type Description Required Default
file_id string The identifier of an uploaded file that contains the screenshot. No
image_url string (uri) The URL of the screenshot image. No
type enum Specifies the event type. For a computer screenshot, this property is
always set to computer_screenshot.
Possible values: computer_screenshot
Yes computer_screenshot

OpenAI.ComputerTool

Computer

A tool that controls a virtual computer.

Name Type Description Required Default
type enum The type of the computer tool. Always computer.
Possible values: computer
Yes computer

OpenAI.ComputerUsePreviewTool

Computer use preview

A tool that controls a virtual computer.

Name Type Description Required Default
display_height integer The height of the computer display. Yes
display_width integer The width of the computer display. Yes
environment OpenAI.ComputerEnvironment Yes
type enum The type of the computer use tool. Always computer_use_preview.
Possible values: computer_use_preview
Yes computer_use_preview

OpenAI.ContainerAutoParam

Name Type Description Required Default
file_ids array of string An optional list of uploaded files to make available to your code.
Constraints: maxItems: 50
No
memory_limit OpenAI.ContainerMemoryLimit or null No
network_policy OpenAI.ContainerNetworkPolicyParam Network access policy for the container. No
skills array of OpenAI.ContainerSkill An optional list of skills referenced by id or inline data.
Constraints: maxItems: 200
No
type enum Automatically creates a container for this request
Possible values: container_auto
Yes container_auto

OpenAI.ContainerFileCitationBody

Container file citation

A citation for a container file used to generate a model response.

Name Type Description Required Default
container_id string The ID of the container file. Yes
end_index integer The index of the last character of the container file citation in the message. Yes
file_id string The ID of the file. Yes
filename string The filename of the container file cited. Yes
start_index integer The index of the first character of the container file citation in the message. Yes
type enum The type of the container file citation. Always container_file_citation.
Possible values: container_file_citation
Yes container_file_citation

OpenAI.ContainerMemoryLimit

Property Value
Type string
Values 1g
4g
16g
64g

OpenAI.ContainerNetworkPolicyAllowlistParam

Name Type Description Required Default
allowed_domains array of string A list of allowed domains when type is allowlist.
Constraints: minItems: 1
Yes
type enum Allow outbound network access only to specified domains. Always allowlist.
Possible values: allowlist
Yes allowlist

OpenAI.ContainerNetworkPolicyDisabledParam

Name Type Description Required Default
type enum Disable outbound network access. Always disabled.
Possible values: disabled
Yes disabled

OpenAI.ContainerNetworkPolicyParam

Network access policy for the container.

Discriminator for OpenAI.ContainerNetworkPolicyParam

This component uses the property type to discriminate between different types:

Type Value Schema
disabled OpenAI.ContainerNetworkPolicyDisabledParam
allowlist OpenAI.ContainerNetworkPolicyAllowlistParam
Name Type Description Required Default
type OpenAI.ContainerNetworkPolicyParamType Yes

OpenAI.ContainerNetworkPolicyParamType

Property Value
Type string
Values disabled
allowlist

OpenAI.ContainerReferenceResource

Container Reference

Represents a container created with /v1/containers.

Name Type Description Required Default
container_id string Yes
type enum The environment type. Always container_reference.
Possible values: container_reference
Yes container_reference

OpenAI.ContainerSkill

Discriminator for OpenAI.ContainerSkill

This component uses the property type to discriminate between different types:

Type Value Schema
skill_reference OpenAI.SkillReferenceParam
inline OpenAI.InlineSkillParam
Name Type Description Required Default
type OpenAI.ContainerSkillType Yes

OpenAI.ContainerSkillType

Property Value
Type string
Values skill_reference
inline

OpenAI.ConversationItem

Conversation item

A single item within a conversation. The set of possible types are the same as the output type of a Response object.

Discriminator for OpenAI.ConversationItem

This component uses the property type to discriminate between different types:

Type Value Schema
message OpenAI.ConversationItemMessage
function_call OpenAI.ConversationItemFunctionToolCall
function_call_output OpenAI.ConversationItemFunctionToolCallOutput
file_search_call OpenAI.ConversationItemFileSearchToolCall
web_search_call OpenAI.ConversationItemWebSearchToolCall
image_generation_call OpenAI.ConversationItemImageGenToolCall
computer_call OpenAI.ConversationItemComputerToolCall
computer_call_output OpenAI.ConversationItemComputerToolCallOutput
tool_search_call OpenAI.ConversationItemToolSearchCall
tool_search_output OpenAI.ConversationItemToolSearchOutput
reasoning OpenAI.ConversationItemReasoningItem
compaction OpenAI.ConversationItemCompactionBody
code_interpreter_call OpenAI.ConversationItemCodeInterpreterToolCall
local_shell_call OpenAI.ConversationItemLocalShellToolCall
local_shell_call_output OpenAI.ConversationItemLocalShellToolCallOutput
shell_call OpenAI.ConversationItemFunctionShellCall
shell_call_output OpenAI.ConversationItemFunctionShellCallOutput
apply_patch_call OpenAI.ConversationItemApplyPatchToolCall
apply_patch_call_output OpenAI.ConversationItemApplyPatchToolCallOutput
mcp_list_tools OpenAI.ConversationItemMcpListTools
mcp_approval_request OpenAI.ConversationItemMcpApprovalRequest
mcp_approval_response OpenAI.ConversationItemMcpApprovalResponseResource
mcp_call OpenAI.ConversationItemMcpToolCall
custom_tool_call OpenAI.ConversationItemCustomToolCallResource
custom_tool_call_output OpenAI.ConversationItemCustomToolCallOutputResource
Name Type Description Required Default
type OpenAI.ConversationItemType Yes

OpenAI.ConversationItemApplyPatchToolCall

Apply patch tool call

A tool call that applies file diffs by creating, deleting, or updating files.

Name Type Description Required Default
call_id string The unique ID of the apply patch tool call generated by the model. Yes
created_by string The ID of the entity that created this tool call. No
id string The unique ID of the apply patch tool call. Populated when this item is returned via API. Yes
operation OpenAI.ApplyPatchFileOperation One of the create_file, delete_file, or update_file operations applied via apply_patch. Yes
└─ type OpenAI.ApplyPatchFileOperationType Yes
status OpenAI.ApplyPatchCallStatus Yes
type enum The type of the item. Always apply_patch_call.
Possible values: apply_patch_call
Yes apply_patch_call

OpenAI.ConversationItemApplyPatchToolCallOutput

Apply patch tool call output

The output emitted by an apply patch tool call.

Name Type Description Required Default
call_id string The unique ID of the apply patch tool call generated by the model. Yes
created_by string The ID of the entity that created this tool call output. No
id string The unique ID of the apply patch tool call output. Populated when this item is returned via API. Yes
output string or null No
status OpenAI.ApplyPatchCallOutputStatus Yes
type enum The type of the item. Always apply_patch_call_output.
Possible values: apply_patch_call_output
Yes apply_patch_call_output

OpenAI.ConversationItemCodeInterpreterToolCall

Code interpreter tool call

A tool call to run code.

Name Type Description Required Default
code string or null Yes
container_id string The ID of the container used to run the code. Yes
id string The unique ID of the code interpreter tool call. Yes
outputs array of OpenAI.CodeInterpreterOutputLogs or OpenAI.CodeInterpreterOutputImage or null Yes
status enum The status of the code interpreter tool call. Valid values are in_progress, completed, incomplete, interpreting, and failed.
Possible values: in_progress, completed, incomplete, interpreting, failed
Yes
type enum The type of the code interpreter tool call. Always code_interpreter_call.
Possible values: code_interpreter_call
Yes code_interpreter_call

OpenAI.ConversationItemCompactionBody

Compaction item

A compaction item generated by the v1/responses/compact API.

Name Type Description Required Default
created_by string The identifier of the actor that created the item. No
encrypted_content string The encrypted content that was produced by compaction. Yes
id string The unique ID of the compaction item. Yes
type enum The type of the item. Always compaction.
Possible values: compaction
Yes compaction

OpenAI.ConversationItemComputerToolCall

Computer tool call

A tool call to a computer use tool.

Name Type Description Required Default
action OpenAI.ComputerAction No
actions OpenAI.ComputerActionList Flattened batched actions for computer_use. Each action includes an
type discriminator and action-specific fields.
No
call_id string An identifier used when responding to the tool call with output. Yes
id string The unique ID of the computer call. Yes
pending_safety_checks array of OpenAI.ComputerCallSafetyCheckParam The pending safety checks for the computer call. Yes
status enum The status of the item. One of in_progress, completed, or
incomplete. Populated when items are returned via API.
Possible values: in_progress, completed, incomplete
Yes
type enum The type of the computer call. Always computer_call.
Possible values: computer_call
Yes computer_call

OpenAI.ConversationItemComputerToolCallOutput

Computer tool call output

The output of a computer tool call.

Name Type Description Required Default
acknowledged_safety_checks array of OpenAI.ComputerCallSafetyCheckParam The safety checks reported by the API that have been acknowledged by the
developer.
No
call_id string The ID of the computer tool call that produced the output. Yes
id string (read-only) The ID of the computer tool call output. Yes
output OpenAI.ComputerScreenshotImage A computer screenshot image used with the computer use tool. Yes
status enum The status of the message input. One of in_progress, completed, or
incomplete. Populated when input items are returned via API.
Possible values: in_progress, completed, incomplete
No
type enum The type of the computer tool call output. Always computer_call_output.
Possible values: computer_call_output
Yes computer_call_output

OpenAI.ConversationItemCustomToolCallOutputResource

ResponseCustomToolCallOutputItem

Name Type Description Required Default
call_id string The call ID, used to map this custom tool call output to a custom tool call. Yes
created_by string The identifier of the actor that created the item. No
id string The unique ID of the custom tool call output in the OpenAI platform. No
output string or array of OpenAI.FunctionAndCustomToolCallOutput The output from the custom tool call generated by your code.
Can be a string or an list of output content.
Yes
status OpenAI.FunctionCallOutputStatusEnum Yes
type enum The type of the custom tool call output. Always custom_tool_call_output.
Possible values: custom_tool_call_output
Yes

OpenAI.ConversationItemCustomToolCallResource

ResponseCustomToolCallItem

Name Type Description Required Default
call_id string An identifier used to map this custom tool call to a tool call output. Yes
created_by string The identifier of the actor that created the item. No
id string The unique ID of the custom tool call in the OpenAI platform. No
input string The input for the custom tool call generated by the model. Yes
name string The name of the custom tool being called. Yes
namespace string The namespace of the custom tool being called. No
status OpenAI.FunctionCallStatus Yes
type enum The type of the custom tool call. Always custom_tool_call.
Possible values: custom_tool_call
Yes

OpenAI.ConversationItemFileSearchToolCall

File search tool call

The results of a file search tool call.

Name Type Description Required Default
id string The unique ID of the file search tool call. Yes
queries array of string The queries used to search for files. Yes
results array of OpenAI.FileSearchToolCallResults or null No
status enum The status of the file search tool call. One of in_progress,
searching, incomplete or failed,
Possible values: in_progress, searching, completed, incomplete, failed
Yes
type enum The type of the file search tool call. Always file_search_call.
Possible values: file_search_call
Yes

OpenAI.ConversationItemFunctionShellCall

Shell tool call

A tool call that executes one or more shell commands in a managed environment.

Name Type Description Required Default
action OpenAI.FunctionShellAction Execute a shell command. Yes
└─ commands array of string Yes
└─ max_output_length integer or null Yes
└─ timeout_ms integer or null Yes
call_id string The unique ID of the shell tool call generated by the model. Yes
created_by string The ID of the entity that created this tool call. No
environment OpenAI.FunctionShellCallEnvironment or null Yes
id string The unique ID of the shell tool call. Populated when this item is returned via API. Yes
status OpenAI.FunctionShellCallStatus Yes
type enum The type of the item. Always shell_call.
Possible values: shell_call
Yes shell_call

OpenAI.ConversationItemFunctionShellCallOutput

Shell call output

The output of a shell tool call that was emitted.

Name Type Description Required Default
call_id string The unique ID of the shell tool call generated by the model. Yes
created_by string The identifier of the actor that created the item. No
id string The unique ID of the shell call output. Populated when this item is returned via API. Yes
max_output_length integer or null Yes
output array of OpenAI.FunctionShellCallOutputContent An array of shell call output contents Yes
status OpenAI.FunctionShellCallOutputStatusEnum Yes
type enum The type of the shell call output. Always shell_call_output.
Possible values: shell_call_output
Yes shell_call_output

OpenAI.ConversationItemFunctionToolCall

Function tool call

A tool call to run a function.

Name Type Description Required Default
arguments string A JSON string of the arguments to pass to the function. Yes
call_id string The unique ID of the function tool call generated by the model. Yes
id string (read-only) The unique ID of the function tool call. Yes
name string The name of the function to run. Yes
namespace string The namespace of the function to run. No
status enum The status of the item. One of in_progress, completed, or
incomplete. Populated when items are returned via API.
Possible values: in_progress, completed, incomplete
No
type enum The type of the function tool call. Always function_call.
Possible values: function_call
Yes

OpenAI.ConversationItemFunctionToolCallOutput

Function tool call output

The output of a function tool call.

Name Type Description Required Default
call_id string The unique ID of the function tool call generated by the model. Yes
id string (read-only) The unique ID of the function tool call output. Populated when this item
is returned via API.
Yes
output string or array of OpenAI.FunctionAndCustomToolCallOutput The output from the function call generated by your code.
Can be a string or an list of output content.
Yes
status enum The status of the item. One of in_progress, completed, or
incomplete. Populated when items are returned via API.
Possible values: in_progress, completed, incomplete
No
type enum The type of the function tool call output. Always function_call_output.
Possible values: function_call_output
Yes

OpenAI.ConversationItemImageGenToolCall

Image generation call

An image generation request made by the model.

Name Type Description Required Default
id string The unique ID of the image generation call. Yes
result string or null Yes
status enum The status of the image generation call.
Possible values: in_progress, completed, generating, failed
Yes
type enum The type of the image generation call. Always image_generation_call.
Possible values: image_generation_call
Yes

OpenAI.ConversationItemList

The conversation item list

A list of Conversation items.

Name Type Description Required Default
data array of OpenAI.ConversationItem A list of conversation items. Yes
first_id string The ID of the first item in the list. Yes
has_more boolean Whether there are more items available. Yes
last_id string The ID of the last item in the list. Yes
object enum The type of object returned, must be list.
Possible values: list
Yes

OpenAI.ConversationItemLocalShellToolCall

Local shell call

A tool call to run a command on the local shell.

Name Type Description Required Default
action OpenAI.LocalShellExecAction Execute a shell command on the server. Yes
call_id string The unique ID of the local shell tool call generated by the model. Yes
id string The unique ID of the local shell call. Yes
status enum The status of the local shell call.
Possible values: in_progress, completed, incomplete
Yes
type enum The type of the local shell call. Always local_shell_call.
Possible values: local_shell_call
Yes

OpenAI.ConversationItemLocalShellToolCallOutput

Local shell call output

The output of a local shell tool call.

Name Type Description Required Default
id string The unique ID of the local shell tool call generated by the model. Yes
output string A JSON string of the output of the local shell tool call. Yes
status string or null No
type enum The type of the local shell tool call output. Always local_shell_call_output.
Possible values: local_shell_call_output
Yes

OpenAI.ConversationItemMcpApprovalRequest

MCP approval request

A request for human approval of a tool invocation.

Name Type Description Required Default
arguments string A JSON string of arguments for the tool. Yes
id string The unique ID of the approval request. Yes
name string The name of the tool to run. Yes
server_label string The label of the MCP server making the request. Yes
type enum The type of the item. Always mcp_approval_request.
Possible values: mcp_approval_request
Yes

OpenAI.ConversationItemMcpApprovalResponseResource

MCP approval response

A response to an MCP approval request.

Name Type Description Required Default
approval_request_id string The ID of the approval request being answered. Yes
approve boolean Whether the request was approved. Yes
id string The unique ID of the approval response Yes
reason string or null No
type enum The type of the item. Always mcp_approval_response.
Possible values: mcp_approval_response
Yes

OpenAI.ConversationItemMcpListTools

MCP list tools

A list of tools available on an MCP server.

Name Type Description Required Default
error OpenAI.RealtimeMCPError No
id string The unique ID of the list. Yes
server_label string The label of the MCP server. Yes
tools array of OpenAI.MCPListToolsTool The tools available on the server. Yes
type enum The type of the item. Always mcp_list_tools.
Possible values: mcp_list_tools
Yes

OpenAI.ConversationItemMcpToolCall

MCP tool call

An invocation of a tool on an MCP server.

Name Type Description Required Default
approval_request_id string or null No
arguments string A JSON string of the arguments passed to the tool. Yes
error OpenAI.RealtimeMCPError No
id string The unique ID of the tool call. Yes
name string The name of the tool that was run. Yes
output string or null No
server_label string The label of the MCP server running the tool. Yes
status OpenAI.MCPToolCallStatus No
type enum The type of the item. Always mcp_call.
Possible values: mcp_call
Yes

OpenAI.ConversationItemMessage

Message

A message to or from the model.

Name Type Description Required Default
content array of OpenAI.MessageContent The content of the message Yes
id string The unique ID of the message. Yes
phase OpenAI.MessagePhase or null No
role OpenAI.MessageRole Yes
status OpenAI.MessageStatus Yes
type enum The type of the message. Always set to message.
Possible values: message
Yes message

OpenAI.ConversationItemReasoningItem

Reasoning

A description of the chain of thought used by a reasoning model while generating a response. Be sure to include these items in your input to the Responses API for subsequent turns of a conversation if you are manually managing context.

Name Type Description Required Default
content array of OpenAI.ReasoningTextContent Reasoning text content. No
encrypted_content string or null No
id string The unique identifier of the reasoning content. Yes
status enum The status of the item. One of in_progress, completed, or
incomplete. Populated when items are returned via API.
Possible values: in_progress, completed, incomplete
No
summary array of OpenAI.SummaryTextContent Reasoning summary content. Yes
type enum The type of the object. Always reasoning.
Possible values: reasoning
Yes

OpenAI.ConversationItemToolSearchCall

Name Type Description Required Default
arguments Arguments used for the tool search call. Yes
call_id string or null Yes
created_by string The identifier of the actor that created the item. No
execution OpenAI.ToolSearchExecutionType Yes
id string The unique ID of the tool search call item. Yes
status OpenAI.FunctionCallStatus Yes
type enum The type of the item. Always tool_search_call.
Possible values: tool_search_call
Yes tool_search_call

OpenAI.ConversationItemToolSearchOutput

Name Type Description Required Default
call_id string or null Yes
created_by string The identifier of the actor that created the item. No
execution OpenAI.ToolSearchExecutionType Yes
id string The unique ID of the tool search output item. Yes
status OpenAI.FunctionCallOutputStatusEnum Yes
tools array of OpenAI.Tool The loaded tool definitions returned by tool search. Yes
type enum The type of the item. Always tool_search_output.
Possible values: tool_search_output
Yes tool_search_output

OpenAI.ConversationItemType

Property Value
Type string
Values message
function_call
function_call_output
file_search_call
web_search_call
image_generation_call
computer_call
computer_call_output
tool_search_call
tool_search_output
reasoning
compaction
code_interpreter_call
local_shell_call
local_shell_call_output
shell_call
shell_call_output
apply_patch_call
apply_patch_call_output
mcp_list_tools
mcp_approval_request
mcp_approval_response
mcp_call
custom_tool_call
custom_tool_call_output

OpenAI.ConversationItemWebSearchToolCall

Web search tool call

The results of a web search tool call.

Name Type Description Required Default
action OpenAI.WebSearchActionSearch or OpenAI.WebSearchActionOpenPage or OpenAI.WebSearchActionFind An object describing the specific action taken in this web search call.
Includes details on how the model used the web (search, open_page, find_in_page).
Yes
id string The unique ID of the web search tool call. Yes
status enum The status of the web search tool call.
Possible values: in_progress, searching, completed, failed
Yes
type enum The type of the web search tool call. Always web_search_call.
Possible values: web_search_call
Yes

OpenAI.ConversationResource

Name Type Description Required Default
created_at integer (unixtime) The time at which the conversation was created, measured in seconds since the Unix epoch. Yes
id string The unique ID of the conversation. Yes
metadata OpenAI.Metadata Set of 16 key-value pairs that can be attached to an object. This can be
useful for storing additional information about the object in a structured
format, and querying for objects via API or the dashboard.
Keys are strings with a maximum length of 64 characters. Values are strings
with a maximum length of 512 characters.
Yes
object enum The object type, which is always conversation.
Possible values: conversation
Yes conversation

OpenAI.CoordParam

Coordinate

An x/y coordinate pair, e.g. { x: 100, y: 200 }.

Name Type Description Required Default
x integer The x-coordinate. Yes
y integer The y-coordinate. Yes

OpenAI.CreateConversationBody

Name Type Description Required Default
items array of OpenAI.InputItem or null No
metadata OpenAI.Metadata or null No

OpenAI.CreateConversationItemsParametersBody

Name Type Description Required Default
items array of OpenAI.InputItem Constraints: maxItems: 20 Yes

OpenAI.CustomGrammarFormatParam

Grammar format

A grammar defined by the user.

Name Type Description Required Default
definition string The grammar definition. Yes
syntax OpenAI.GrammarSyntax1 Yes
type enum Grammar format. Always grammar.
Possible values: grammar
Yes grammar

OpenAI.CustomTextFormatParam

Text format

Unconstrained free-form text.

Name Type Description Required Default
type enum Unconstrained text format. Always text.
Possible values: text
Yes text

OpenAI.CustomToolParam

Custom tool

A custom tool that processes input using a specified format. Learn more about custom tools

Name Type Description Required Default
defer_loading boolean Whether this tool should be deferred and discovered via tool search. No
description string Optional description of the custom tool, used to provide more context. No
format OpenAI.CustomToolParamFormat The input format for the custom tool. Default is unconstrained text. No
└─ type OpenAI.CustomToolParamFormatType Yes
name string The name of the custom tool, used to identify it in tool calls. Yes
type enum The type of the custom tool. Always custom.
Possible values: custom
Yes custom

OpenAI.CustomToolParamFormat

The input format for the custom tool. Default is unconstrained text.

Discriminator for OpenAI.CustomToolParamFormat

This component uses the property type to discriminate between different types:

Type Value Schema
text OpenAI.CustomTextFormatParam
grammar OpenAI.CustomGrammarFormatParam
Name Type Description Required Default
type OpenAI.CustomToolParamFormatType Yes

OpenAI.CustomToolParamFormatType

Property Value
Type string
Values text
grammar

OpenAI.DeletedConversationResource

Name Type Description Required Default
deleted boolean Yes
id string Yes
object enum
Possible values: conversation.deleted
Yes conversation.deleted

OpenAI.DetailEnum

Property Value
Type string
Values low
high
auto
original

OpenAI.DoubleClickAction

DoubleClick

A double click action.

Name Type Description Required Default
keys array of string or null Yes
type enum Specifies the event type. For a double click action, this property is always set to double_click.
Possible values: double_click
Yes double_click
x integer The x-coordinate where the double click occurred. Yes
y integer The y-coordinate where the double click occurred. Yes

OpenAI.DragParam

Drag

A drag action.

Name Type Description Required Default
keys array of string or null No
path array of OpenAI.CoordParam An array of coordinates representing the path of the drag action. Coordinates will appear as an array of objects, eg
<br> [ { x: 100, y: 200 }, { x: 200, y: 300 } ]<br>
Yes
type enum Specifies the event type. For a drag action, this property is always set to drag.
Possible values: drag
Yes drag

OpenAI.EasyInputMessage

Input message

A message input to the model with a role indicating instruction following hierarchy. Instructions given with the developer or system role take precedence over instructions given with the user role. Messages with the assistant role are presumed to have been generated by the model in previous interactions.

Name Type Description Required Default
content string or OpenAI.InputMessageContentList Text, image, or audio input to the model, used to generate a response.
Can also contain previous assistant responses.
Yes
phase OpenAI.MessagePhase or null No
role enum The role of the message input. One of user, assistant, system, or
developer.
Possible values: user, assistant, system, developer
Yes
status enum The status of item. One of in_progress, completed, or
incomplete. Populated when items are returned via API.
Possible values: in_progress, completed, incomplete
No
type enum The type of the message input. Always message.
Possible values: message
Yes

OpenAI.EmptyModelParam

Type: object

OpenAI.FileCitationBody

File citation

A citation to a file.

Name Type Description Required Default
file_id string The ID of the file. Yes
filename string The filename of the file cited. Yes
index integer The index of the file in the list of files. Yes
type enum The type of the file citation. Always file_citation.
Possible values: file_citation
Yes file_citation

OpenAI.FileInputDetail

Property Value
Type string
Values low
high

OpenAI.FilePath

File path

A path to a file.

Name Type Description Required Default
file_id string The ID of the file. Yes
index integer The index of the file in the list of files. Yes
type enum The type of the file path. Always file_path.
Possible values: file_path
Yes

OpenAI.FileSearchTool

File search

A tool that searches for relevant content from uploaded files.

Name Type Description Required Default
filters OpenAI.Filters or null No
max_num_results integer The maximum number of results to return. This number should be between 1 and 50 inclusive. No
ranking_options OpenAI.RankingOptions No
└─ hybrid_search OpenAI.HybridSearchOptions Weights that control how reciprocal rank fusion balances semantic embedding matches versus sparse keyword matches when hybrid search is enabled. No
└─ ranker OpenAI.RankerVersionType The ranker to use for the file search. No
└─ score_threshold number The score threshold for the file search, a number between 0 and 1. Numbers closer to 1 will attempt to return only the most relevant results, but may return fewer results. No
type enum The type of the file search tool. Always file_search.
Possible values: file_search
Yes file_search
vector_store_ids array of string The IDs of the vector stores to search. Yes

OpenAI.FileSearchToolCallResults

Name Type Description Required Default
attributes OpenAI.VectorStoreFileAttributes or null No
file_id string No
filename string No
score number (float) No
text string No

OpenAI.Filters

Type: OpenAI.ComparisonFilter or OpenAI.CompoundFilter

OpenAI.FunctionAndCustomToolCallOutput

Discriminator for OpenAI.FunctionAndCustomToolCallOutput

This component uses the property type to discriminate between different types:

Type Value Schema
input_text OpenAI.FunctionAndCustomToolCallOutputInputTextContent
input_image OpenAI.FunctionAndCustomToolCallOutputInputImageContent
input_file OpenAI.FunctionAndCustomToolCallOutputInputFileContent
Name Type Description Required Default
type OpenAI.FunctionAndCustomToolCallOutputType Yes

OpenAI.FunctionAndCustomToolCallOutputInputFileContent

Input file

A file input to the model.

Name Type Description Required Default
detail OpenAI.FileInputDetail No
file_data string The content of the file to be sent to the model. No
file_id string or null No
file_url string (uri) The URL of the file to be sent to the model. No
filename string The name of the file to be sent to the model. No
type enum The type of the input item. Always input_file.
Possible values: input_file
Yes input_file

OpenAI.FunctionAndCustomToolCallOutputInputImageContent

Input image

An image input to the model.

Name Type Description Required Default
detail OpenAI.ImageDetail Yes
file_id string or null No
image_url string or null No
type enum The type of the input item. Always input_image.
Possible values: input_image
Yes input_image

OpenAI.FunctionAndCustomToolCallOutputInputTextContent

Input text

A text input to the model.

Name Type Description Required Default
text string The text input to the model. Yes
type enum The type of the input item. Always input_text.
Possible values: input_text
Yes input_text

OpenAI.FunctionAndCustomToolCallOutputType

Property Value
Type string
Values input_text
input_image
input_file

OpenAI.FunctionCallItemStatus

Property Value
Type string
Values in_progress
completed
incomplete

OpenAI.FunctionCallOutputStatusEnum

Property Value
Type string
Values in_progress
completed
incomplete

OpenAI.FunctionCallStatus

Property Value
Type string
Values in_progress
completed
incomplete

OpenAI.FunctionShellAction

Shell exec action

Execute a shell command.

Name Type Description Required Default
commands array of string Yes
max_output_length integer or null Yes
timeout_ms integer or null Yes

OpenAI.FunctionShellActionParam

Shell action

Commands and limits describing how to run the shell tool call.

Name Type Description Required Default
commands array of string Ordered shell commands for the execution environment to run. Yes
max_output_length integer or null No
timeout_ms integer or null No

OpenAI.FunctionShellCallEnvironment

Discriminator for OpenAI.FunctionShellCallEnvironment

This component uses the property type to discriminate between different types:

Type Value Schema
local OpenAI.LocalEnvironmentResource
container_reference OpenAI.ContainerReferenceResource
Name Type Description Required Default
type OpenAI.FunctionShellCallEnvironmentType Yes

OpenAI.FunctionShellCallEnvironmentType

Property Value
Type string
Values local
container_reference

OpenAI.FunctionShellCallItemParamEnvironment

The environment to execute the shell commands in.

Discriminator for OpenAI.FunctionShellCallItemParamEnvironment

This component uses the property type to discriminate between different types:

Type Value Schema
local OpenAI.FunctionShellCallItemParamEnvironmentLocalEnvironmentParam
container_reference OpenAI.FunctionShellCallItemParamEnvironmentContainerReferenceParam
Name Type Description Required Default
type OpenAI.FunctionShellCallItemParamEnvironmentType Yes

OpenAI.FunctionShellCallItemParamEnvironmentContainerReferenceParam

Name Type Description Required Default
container_id string The ID of the referenced container. Yes
type enum References a container created with the /v1/containers endpoint
Possible values: container_reference
Yes container_reference

OpenAI.FunctionShellCallItemParamEnvironmentLocalEnvironmentParam

Name Type Description Required Default
skills array of OpenAI.LocalSkillParam An optional list of skills.
Constraints: maxItems: 200
No
type enum Use a local computer environment.
Possible values: local
Yes local

OpenAI.FunctionShellCallItemParamEnvironmentType

Property Value
Type string
Values local
container_reference

OpenAI.FunctionShellCallItemStatus

Shell call status

Status values reported for shell tool calls.

Property Value
Type string
Values in_progress
completed
incomplete

OpenAI.FunctionShellCallOutputContent

Shell call output content

The content of a shell tool call output that was emitted.

Name Type Description Required Default
created_by string The identifier of the actor that created the item. No
outcome OpenAI.FunctionShellCallOutputOutcome Represents either an exit outcome (with an exit code) or a timeout outcome for a shell call output chunk. Yes
└─ type OpenAI.FunctionShellCallOutputOutcomeType Yes
stderr string The standard error output that was captured. Yes
stdout string The standard output that was captured. Yes

OpenAI.FunctionShellCallOutputContentParam

Shell output content

Captured stdout and stderr for a portion of a shell tool call output.

Name Type Description Required Default
outcome OpenAI.FunctionShellCallOutputOutcomeParam The exit or timeout outcome associated with this shell call. Yes
└─ type OpenAI.FunctionShellCallOutputOutcomeParamType Yes
stderr string Captured stderr output for the shell call.
Constraints: maxLength: 10485760
Yes
stdout string Captured stdout output for the shell call.
Constraints: maxLength: 10485760
Yes

OpenAI.FunctionShellCallOutputExitOutcome

Shell call exit outcome

Indicates that the shell commands finished and returned an exit code.

Name Type Description Required Default
exit_code integer Exit code from the shell process. Yes
type enum The outcome type. Always exit.
Possible values: exit
Yes exit

OpenAI.FunctionShellCallOutputExitOutcomeParam

Shell call exit outcome

Indicates that the shell commands finished and returned an exit code.

Name Type Description Required Default
exit_code integer The exit code returned by the shell process. Yes
type enum The outcome type. Always exit.
Possible values: exit
Yes exit

OpenAI.FunctionShellCallOutputOutcome

Shell call outcome

Represents either an exit outcome (with an exit code) or a timeout outcome for a shell call output chunk.

Discriminator for OpenAI.FunctionShellCallOutputOutcome

This component uses the property type to discriminate between different types:

Type Value Schema
timeout OpenAI.FunctionShellCallOutputTimeoutOutcome
exit OpenAI.FunctionShellCallOutputExitOutcome
Name Type Description Required Default
type OpenAI.FunctionShellCallOutputOutcomeType Yes

OpenAI.FunctionShellCallOutputOutcomeParam

Shell call outcome

The exit or timeout outcome associated with this shell call.

Discriminator for OpenAI.FunctionShellCallOutputOutcomeParam

This component uses the property type to discriminate between different types:

Type Value Schema
timeout OpenAI.FunctionShellCallOutputTimeoutOutcomeParam
exit OpenAI.FunctionShellCallOutputExitOutcomeParam
Name Type Description Required Default
type OpenAI.FunctionShellCallOutputOutcomeParamType Yes

OpenAI.FunctionShellCallOutputOutcomeParamType

Property Value
Type string
Values timeout
exit

OpenAI.FunctionShellCallOutputOutcomeType

Property Value
Type string
Values timeout
exit

OpenAI.FunctionShellCallOutputStatusEnum

Property Value
Type string
Values in_progress
completed
incomplete

OpenAI.FunctionShellCallOutputTimeoutOutcome

Shell call timeout outcome

Indicates that the shell call exceeded its configured time limit.

Name Type Description Required Default
type enum The outcome type. Always timeout.
Possible values: timeout
Yes timeout

OpenAI.FunctionShellCallOutputTimeoutOutcomeParam

Shell call timeout outcome

Indicates that the shell call exceeded its configured time limit.

Name Type Description Required Default
type enum The outcome type. Always timeout.
Possible values: timeout
Yes timeout

OpenAI.FunctionShellCallStatus

Property Value
Type string
Values in_progress
completed
incomplete

OpenAI.FunctionShellToolParam

Shell tool

A tool that allows the model to execute shell commands.

Name Type Description Required Default
environment OpenAI.FunctionShellToolParamEnvironment or null No
type enum The type of the shell tool. Always shell.
Possible values: shell
Yes shell

OpenAI.FunctionShellToolParamEnvironment

Discriminator for OpenAI.FunctionShellToolParamEnvironment

This component uses the property type to discriminate between different types:

Type Value Schema
local OpenAI.FunctionShellToolParamEnvironmentLocalEnvironmentParam
container_reference OpenAI.FunctionShellToolParamEnvironmentContainerReferenceParam
container_auto OpenAI.ContainerAutoParam
Name Type Description Required Default
type OpenAI.FunctionShellToolParamEnvironmentType Yes

OpenAI.FunctionShellToolParamEnvironmentContainerReferenceParam

Name Type Description Required Default
container_id string The ID of the referenced container. Yes
type enum References a container created with the /v1/containers endpoint
Possible values: container_reference
Yes container_reference

OpenAI.FunctionShellToolParamEnvironmentLocalEnvironmentParam

Name Type Description Required Default
skills array of OpenAI.LocalSkillParam An optional list of skills.
Constraints: maxItems: 200
No
type enum Use a local computer environment.
Possible values: local
Yes local

OpenAI.FunctionShellToolParamEnvironmentType

Property Value
Type string
Values container_auto
local
container_reference

OpenAI.FunctionTool

Function

Defines a function in your own code the model can choose to call.

Name Type Description Required Default
defer_loading boolean Whether this function is deferred and loaded via tool search. No
description string or null No
name string The name of the function to call. Yes
parameters object or null Yes
strict boolean or null Yes
type enum The type of the function tool. Always function.
Possible values: function
Yes function

OpenAI.FunctionToolParam

Name Type Description Required Default
defer_loading boolean Whether this function should be deferred and discovered via tool search. No
description string or null No
name string Constraints: minLength: 1, maxLength: 128, pattern: ^[a-zA-Z0-9_-]+$ Yes
parameters OpenAI.EmptyModelParam or null No
strict boolean or null No
type enum
Possible values: function
Yes function

OpenAI.GrammarSyntax1

Property Value
Type string
Values lark
regex

OpenAI.HybridSearchOptions

Name Type Description Required Default
embedding_weight number The weight of the embedding in the reciprocal ranking fusion. Yes
text_weight number The weight of the text in the reciprocal ranking fusion. Yes

OpenAI.ImageDetail

Property Value
Type string
Values low
high
auto
original

OpenAI.ImageGenActionEnum

Property Value
Type string
Values generate
edit
auto

OpenAI.ImageGenTool

Image generation tool

A tool that generates images using the GPT image models.

Valid models:

gpt-image-1
gpt-image-1-mini
gpt-image-1.5
Name Type Description Required Default
action OpenAI.ImageGenActionEnum No
background enum Background type for the generated image. One of transparent,
opaque, or auto. Default: auto.
Possible values: transparent, opaque, auto
No auto
input_fidelity OpenAI.InputFidelity or null No
input_image_mask OpenAI.ImageGenToolInputImageMask No
└─ file_id string No
└─ image_url string (uri) No
model string (see valid models below) No
moderation enum Moderation level for the generated image. Default: auto.
Possible values: auto, low
No auto
output_compression integer Compression level for the output image. Default: 100.
Constraints: min: 0, max: 100
No 100
output_format enum The output format of the generated image. One of png, webp, or
jpeg. Default: png.
Possible values: png, webp, jpeg
No png
partial_images integer Number of partial images to generate in streaming mode, from 0 (default value) to 3.
Constraints: min: 0, max: 3
No
quality enum The quality of the generated image. One of low, medium, high,
or auto. Default: auto.
Possible values: low, medium, high, auto
No auto
size string (see valid models below) The size of the generated images. For gpt-image-2 and gpt-image-2-2026-04-21, arbitrary resolutions are supported as WIDTHxHEIGHT strings, for example 1536x864. Width and height must both be divisible by 16 and the requested aspect ratio must be between 1:3 and 3:1. Resolutions above 2560x1440 are experimental, and the maximum supported resolution is 3840x2160. The requested size must also satisfy the model's current pixel and edge limits. The standard sizes 1024x1024, 1536x1024, and 1024x1536 are supported by the GPT image models; auto is supported for models that allow automatic sizing. For dall-e-2, use one of 256x256, 512x512, or 1024x1024. For dall-e-3, use one of 1024x1024, 1792x1024, or 1024x1792. No
type enum The type of the image generation tool. Always image_generation.
Possible values: image_generation
Yes image_generation

OpenAI.ImageGenToolInputImageMask

Name Type Description Required Default
file_id string No
image_url string (uri) No

OpenAI.IncludeEnum

Specify additional output data to include in the model response. Currently supported values are:

  • web_search_call.results: Include the search results of the web search tool call.
  • web_search_call.action.sources: Include the sources of the web search tool call.
  • code_interpreter_call.outputs: Includes the outputs of python code execution in code interpreter tool call items.
  • computer_call_output.output.image_url: Include image urls from the computer call output.
  • file_search_call.results: Include the search results of the file search tool call.
  • message.input_image.image_url: Include image urls from the input message.
  • message.output_text.logprobs: Include logprobs with assistant messages.
  • reasoning.encrypted_content: Includes an encrypted version of reasoning tokens in reasoning item outputs. This enables reasoning items to be used in multi-turn conversations when using the Responses API statelessly (like when the store parameter is set to false, or when an organization is enrolled in the zero data retention program).
Property Value
Description Specify additional output data to include in the model response. Currently supported values are:
- web_search_call.results: Include the search results of the web search tool call.
- web_search_call.action.sources: Include the sources of the web search tool call.
- code_interpreter_call.outputs: Includes the outputs of python code execution in code interpreter tool call items.
- computer_call_output.output.image_url: Include image urls from the computer call output.
- file_search_call.results: Include the search results of the file search tool call.
- message.input_image.image_url: Include image urls from the input message.
- message.output_text.logprobs: Include logprobs with assistant messages.
- reasoning.encrypted_content: Includes an encrypted version of reasoning tokens in reasoning item outputs. This enables reasoning items to be used in multi-turn conversations when using the Responses API statelessly (like when the store parameter is set to false, or when an organization is enrolled in the zero data retention program).
Type string
Values file_search_call.results
web_search_call.results
web_search_call.action.sources
message.input_image.image_url
computer_call_output.output.image_url
code_interpreter_call.outputs
reasoning.encrypted_content
message.output_text.logprobs

OpenAI.InlineSkillParam

Name Type Description Required Default
description string The description of the skill. Yes
name string The name of the skill. Yes
source OpenAI.InlineSkillSourceParam Inline skill payload Yes
└─ data string Base64-encoded skill zip bundle.
Constraints: minLength: 1, maxLength: 70254592
Yes
└─ media_type enum The media type of the inline skill payload. Must be application/zip.
Possible values: application/zip
Yes application/zip
└─ type enum The type of the inline skill source. Must be base64.
Possible values: base64
Yes base64
type enum Defines an inline skill for this request.
Possible values: inline
Yes inline

OpenAI.InlineSkillSourceParam

Inline skill payload

Name Type Description Required Default
data string Base64-encoded skill zip bundle.
Constraints: minLength: 1, maxLength: 70254592
Yes
media_type enum The media type of the inline skill payload. Must be application/zip.
Possible values: application/zip
Yes application/zip
type enum The type of the inline skill source. Must be base64.
Possible values: base64
Yes base64

OpenAI.InputContent

Discriminator for OpenAI.InputContent

This component uses the property type to discriminate between different types:

Type Value Schema
input_text OpenAI.InputContentInputTextContent
input_image OpenAI.InputContentInputImageContent
input_file OpenAI.InputContentInputFileContent
Name Type Description Required Default
type OpenAI.InputContentType Yes

OpenAI.InputContentInputFileContent

Input file

A file input to the model.

Name Type Description Required Default
detail OpenAI.FileInputDetail No
file_data string The content of the file to be sent to the model. No
file_id string or null No
file_url string (uri) The URL of the file to be sent to the model. No
filename string The name of the file to be sent to the model. No
type enum The type of the input item. Always input_file.
Possible values: input_file
Yes input_file

OpenAI.InputContentInputImageContent

Input image

An image input to the model.

Name Type Description Required Default
detail OpenAI.ImageDetail Yes
file_id string or null No
image_url string or null No
type enum The type of the input item. Always input_image.
Possible values: input_image
Yes input_image

OpenAI.InputContentInputTextContent

Input text

A text input to the model.

Name Type Description Required Default
text string The text input to the model. Yes
type enum The type of the input item. Always input_text.
Possible values: input_text
Yes input_text

OpenAI.InputContentType

Property Value
Type string
Values input_text
input_image
input_file

OpenAI.InputFidelity

Control how much effort the model will exert to match the style and features, especially facial features, of input images. This parameter is only supported for gpt-image-1 and gpt-image-1.5 and later models, unsupported for gpt-image-1-mini. Supports high and low. Defaults to low.

Property Value
Type string
Values high
low

OpenAI.InputFileContentParam

Input file

A file input to the model.

Name Type Description Required Default
detail OpenAI.FileInputDetail No
file_data string or null No
file_id string or null No
file_url string or null No
filename string or null No
type enum The type of the input item. Always input_file.
Possible values: input_file
Yes input_file

OpenAI.InputImageContentParamAutoParam

Input image

An image input to the model. Learn about image inputs

Name Type Description Required Default
detail OpenAI.DetailEnum or null No
file_id string or null No
image_url string or null No
type enum The type of the input item. Always input_image.
Possible values: input_image
Yes input_image

OpenAI.InputItem

An item representing part of the context for the response to be generated by the model. Can contain text, images, and audio inputs, as well as previous assistant responses and tool call outputs.

Discriminator for OpenAI.InputItem

This component uses the property type to discriminate between different types:

Type Value Schema
message OpenAI.EasyInputMessage
item_reference OpenAI.ItemReferenceParam
output_message OpenAI.InputItemOutputMessage
file_search_call OpenAI.InputItemFileSearchToolCall
computer_call OpenAI.InputItemComputerToolCall
computer_call_output OpenAI.InputItemComputerCallOutputItemParam
web_search_call OpenAI.InputItemWebSearchToolCall
function_call OpenAI.InputItemFunctionToolCall
function_call_output OpenAI.InputItemFunctionCallOutputItemParam
tool_search_call OpenAI.InputItemToolSearchCallItemParam
tool_search_output OpenAI.InputItemToolSearchOutputItemParam
reasoning OpenAI.InputItemReasoningItem
compaction OpenAI.InputItemCompactionSummaryItemParam
image_generation_call OpenAI.InputItemImageGenToolCall
code_interpreter_call OpenAI.InputItemCodeInterpreterToolCall
local_shell_call OpenAI.InputItemLocalShellToolCall
local_shell_call_output OpenAI.InputItemLocalShellToolCallOutput
shell_call OpenAI.InputItemFunctionShellCallItemParam
shell_call_output OpenAI.InputItemFunctionShellCallOutputItemParam
apply_patch_call OpenAI.InputItemApplyPatchToolCallItemParam
apply_patch_call_output OpenAI.InputItemApplyPatchToolCallOutputItemParam
mcp_list_tools OpenAI.InputItemMcpListTools
mcp_approval_request OpenAI.InputItemMcpApprovalRequest
mcp_approval_response OpenAI.InputItemMcpApprovalResponse
mcp_call OpenAI.InputItemMcpToolCall
custom_tool_call_output OpenAI.InputItemCustomToolCallOutput
custom_tool_call OpenAI.InputItemCustomToolCall
tool_approval_response AzureToolApprovalResponse
Name Type Description Required Default
type OpenAI.InputItemType Yes

OpenAI.InputItemApplyPatchToolCallItemParam

Apply patch tool call

A tool call representing a request to create, delete, or update files using diff patches.

Name Type Description Required Default
call_id string The unique ID of the apply patch tool call generated by the model.
Constraints: minLength: 1, maxLength: 64
Yes
id string or null No
operation OpenAI.ApplyPatchOperationParam One of the create_file, delete_file, or update_file operations supplied to the apply_patch tool. Yes
└─ type OpenAI.ApplyPatchOperationParamType Yes
status OpenAI.ApplyPatchCallStatusParam Status values reported for apply_patch tool calls. Yes
type enum The type of the item. Always apply_patch_call.
Possible values: apply_patch_call
Yes apply_patch_call

OpenAI.InputItemApplyPatchToolCallOutputItemParam

Apply patch tool call output

The streamed output emitted by an apply patch tool call.

Name Type Description Required Default
call_id string The unique ID of the apply patch tool call generated by the model.
Constraints: minLength: 1, maxLength: 64
Yes
id string or null No
output string or null No
status OpenAI.ApplyPatchCallOutputStatusParam Outcome values reported for apply_patch tool call outputs. Yes
type enum The type of the item. Always apply_patch_call_output.
Possible values: apply_patch_call_output
Yes apply_patch_call_output

OpenAI.InputItemCodeInterpreterToolCall

Code interpreter tool call

A tool call to run code.

Name Type Description Required Default
code string or null Yes
container_id string The ID of the container used to run the code. Yes
id string The unique ID of the code interpreter tool call. Yes
outputs array of OpenAI.CodeInterpreterOutputLogs or OpenAI.CodeInterpreterOutputImage or null Yes
status enum The status of the code interpreter tool call. Valid values are in_progress, completed, incomplete, interpreting, and failed.
Possible values: in_progress, completed, incomplete, interpreting, failed
Yes
type enum The type of the code interpreter tool call. Always code_interpreter_call.
Possible values: code_interpreter_call
Yes code_interpreter_call

OpenAI.InputItemCompactionSummaryItemParam

Compaction item

A compaction item generated by the v1/responses/compact API.

Name Type Description Required Default
encrypted_content string The encrypted content of the compaction summary.
Constraints: maxLength: 10485760
Yes
id string or null No
type enum The type of the item. Always compaction.
Possible values: compaction
Yes compaction

OpenAI.InputItemComputerCallOutputItemParam

Computer tool call output

The output of a computer tool call.

Name Type Description Required Default
acknowledged_safety_checks array of OpenAI.ComputerCallSafetyCheckParam or null No
call_id string The ID of the computer tool call that produced the output.
Constraints: minLength: 1, maxLength: 64
Yes
id string or null No
output OpenAI.ComputerScreenshotImage A computer screenshot image used with the computer use tool. Yes
status OpenAI.FunctionCallItemStatus or null No
type enum The type of the computer tool call output. Always computer_call_output.
Possible values: computer_call_output
Yes computer_call_output

OpenAI.InputItemComputerToolCall

Computer tool call

A tool call to a computer use tool.

Name Type Description Required Default
action OpenAI.ComputerAction No
actions OpenAI.ComputerActionList Flattened batched actions for computer_use. Each action includes an
type discriminator and action-specific fields.
No
call_id string An identifier used when responding to the tool call with output. Yes
id string The unique ID of the computer call. Yes
pending_safety_checks array of OpenAI.ComputerCallSafetyCheckParam The pending safety checks for the computer call. Yes
status enum The status of the item. One of in_progress, completed, or
incomplete. Populated when items are returned via API.
Possible values: in_progress, completed, incomplete
Yes
type enum The type of the computer call. Always computer_call.
Possible values: computer_call
Yes computer_call

OpenAI.InputItemCustomToolCall

Custom tool call

A call to a custom tool created by the model.

Name Type Description Required Default
call_id string An identifier used to map this custom tool call to a tool call output. Yes
id string The unique ID of the custom tool call in the OpenAI platform. No
input string The input for the custom tool call generated by the model. Yes
name string The name of the custom tool being called. Yes
namespace string The namespace of the custom tool being called. No
type enum The type of the custom tool call. Always custom_tool_call.
Possible values: custom_tool_call
Yes

OpenAI.InputItemCustomToolCallOutput

Custom tool call output

The output of a custom tool call from your code, being sent back to the model.

Name Type Description Required Default
call_id string The call ID, used to map this custom tool call output to a custom tool call. Yes
id string The unique ID of the custom tool call output in the OpenAI platform. No
output string or array of OpenAI.FunctionAndCustomToolCallOutput The output from the custom tool call generated by your code.
Can be a string or an list of output content.
Yes
type enum The type of the custom tool call output. Always custom_tool_call_output.
Possible values: custom_tool_call_output
Yes

OpenAI.InputItemFileSearchToolCall

File search tool call

The results of a file search tool call.

Name Type Description Required Default
id string The unique ID of the file search tool call. Yes
queries array of string The queries used to search for files. Yes
results array of OpenAI.FileSearchToolCallResults or null No
status enum The status of the file search tool call. One of in_progress,
searching, incomplete or failed,
Possible values: in_progress, searching, completed, incomplete, failed
Yes
type enum The type of the file search tool call. Always file_search_call.
Possible values: file_search_call
Yes

OpenAI.InputItemFunctionCallOutputItemParam

Function tool call output

The output of a function tool call.

Name Type Description Required Default
call_id string The unique ID of the function tool call generated by the model.
Constraints: minLength: 1, maxLength: 64
Yes
id string or null No
output string or array of OpenAI.InputTextContentParam or OpenAI.InputImageContentParamAutoParam or OpenAI.InputFileContentParam Text, image, or file output of the function tool call. Yes
status OpenAI.FunctionCallItemStatus or null No
type enum The type of the function tool call output. Always function_call_output.
Possible values: function_call_output
Yes function_call_output

OpenAI.InputItemFunctionShellCallItemParam

Shell tool call

A tool representing a request to execute one or more shell commands.

Name Type Description Required Default
action OpenAI.FunctionShellActionParam Commands and limits describing how to run the shell tool call. Yes
└─ commands array of string Ordered shell commands for the execution environment to run. Yes
└─ max_output_length integer or null No
└─ timeout_ms integer or null No
call_id string The unique ID of the shell tool call generated by the model.
Constraints: minLength: 1, maxLength: 64
Yes
environment OpenAI.FunctionShellCallItemParamEnvironment or null No
id string or null No
status OpenAI.FunctionShellCallItemStatus or null No
type enum The type of the item. Always shell_call.
Possible values: shell_call
Yes shell_call

OpenAI.InputItemFunctionShellCallOutputItemParam

Shell tool call output

The streamed output items emitted by a shell tool call.

Name Type Description Required Default
call_id string The unique ID of the shell tool call generated by the model.
Constraints: minLength: 1, maxLength: 64
Yes
id string or null No
max_output_length integer or null No
output array of OpenAI.FunctionShellCallOutputContentParam Captured chunks of stdout and stderr output, along with their associated outcomes. Yes
status OpenAI.FunctionShellCallItemStatus or null No
type enum The type of the item. Always shell_call_output.
Possible values: shell_call_output
Yes shell_call_output

OpenAI.InputItemFunctionToolCall

Function tool call

A tool call to run a function.

Name Type Description Required Default
arguments string A JSON string of the arguments to pass to the function. Yes
call_id string The unique ID of the function tool call generated by the model. Yes
id string (read-only) The unique ID of the function tool call. Yes
name string The name of the function to run. Yes
namespace string The namespace of the function to run. No
status enum The status of the item. One of in_progress, completed, or
incomplete. Populated when items are returned via API.
Possible values: in_progress, completed, incomplete
No
type enum The type of the function tool call. Always function_call.
Possible values: function_call
Yes

OpenAI.InputItemImageGenToolCall

Image generation call

An image generation request made by the model.

Name Type Description Required Default
id string The unique ID of the image generation call. Yes
result string or null Yes
status enum The status of the image generation call.
Possible values: in_progress, completed, generating, failed
Yes
type enum The type of the image generation call. Always image_generation_call.
Possible values: image_generation_call
Yes

OpenAI.InputItemLocalShellToolCall

Local shell call

A tool call to run a command on the local shell.

Name Type Description Required Default
action OpenAI.LocalShellExecAction Execute a shell command on the server. Yes
call_id string The unique ID of the local shell tool call generated by the model. Yes
id string The unique ID of the local shell call. Yes
status enum The status of the local shell call.
Possible values: in_progress, completed, incomplete
Yes
type enum The type of the local shell call. Always local_shell_call.
Possible values: local_shell_call
Yes

OpenAI.InputItemLocalShellToolCallOutput

Local shell call output

The output of a local shell tool call.

Name Type Description Required Default
id string The unique ID of the local shell tool call generated by the model. Yes
output string A JSON string of the output of the local shell tool call. Yes
status string or null No
type enum The type of the local shell tool call output. Always local_shell_call_output.
Possible values: local_shell_call_output
Yes

OpenAI.InputItemMcpApprovalRequest

MCP approval request

A request for human approval of a tool invocation.

Name Type Description Required Default
arguments string A JSON string of arguments for the tool. Yes
id string The unique ID of the approval request. Yes
name string The name of the tool to run. Yes
server_label string The label of the MCP server making the request. Yes
type enum The type of the item. Always mcp_approval_request.
Possible values: mcp_approval_request
Yes

OpenAI.InputItemMcpApprovalResponse

MCP approval response

A response to an MCP approval request.

Name Type Description Required Default
approval_request_id string The ID of the approval request being answered. Yes
approve boolean Whether the request was approved. Yes
id string or null No
reason string or null No
type enum The type of the item. Always mcp_approval_response.
Possible values: mcp_approval_response
Yes

OpenAI.InputItemMcpListTools

MCP list tools

A list of tools available on an MCP server.

Name Type Description Required Default
error OpenAI.RealtimeMCPError No
id string The unique ID of the list. Yes
server_label string The label of the MCP server. Yes
tools array of OpenAI.MCPListToolsTool The tools available on the server. Yes
type enum The type of the item. Always mcp_list_tools.
Possible values: mcp_list_tools
Yes

OpenAI.InputItemMcpToolCall

MCP tool call

An invocation of a tool on an MCP server.

Name Type Description Required Default
approval_request_id string or null No
arguments string A JSON string of the arguments passed to the tool. Yes
error OpenAI.RealtimeMCPError No
id string The unique ID of the tool call. Yes
name string The name of the tool that was run. Yes
output string or null No
server_label string The label of the MCP server running the tool. Yes
status OpenAI.MCPToolCallStatus No
type enum The type of the item. Always mcp_call.
Possible values: mcp_call
Yes

OpenAI.InputItemOutputMessage

Output message

An output message from the model.

Name Type Description Required Default
content array of OpenAI.OutputMessageContent The content of the output message. Yes
id string The unique ID of the output message. Yes
phase OpenAI.MessagePhase or null No
role enum The role of the output message. Always assistant.
Possible values: assistant
Yes
status enum The status of the message input. One of in_progress, completed, or
incomplete. Populated when input items are returned via API.
Possible values: in_progress, completed, incomplete
Yes
type enum The type of the output message. Always message.
Possible values: output_message
Yes

OpenAI.InputItemReasoningItem

Reasoning

A description of the chain of thought used by a reasoning model while generating a response. Be sure to include these items in your input to the Responses API for subsequent turns of a conversation if you are manually managing context.

Name Type Description Required Default
content array of OpenAI.ReasoningTextContent Reasoning text content. No
encrypted_content string or null No
id string The unique identifier of the reasoning content. Yes
status enum The status of the item. One of in_progress, completed, or
incomplete. Populated when items are returned via API.
Possible values: in_progress, completed, incomplete
No
summary array of OpenAI.SummaryTextContent Reasoning summary content. Yes
type enum The type of the object. Always reasoning.
Possible values: reasoning
Yes

OpenAI.InputItemToolSearchCallItemParam

Name Type Description Required Default
arguments OpenAI.EmptyModelParam Yes
call_id string or null No
execution OpenAI.ToolSearchExecutionType No
id string or null No
status OpenAI.FunctionCallItemStatus or null No
type enum The item type. Always tool_search_call.
Possible values: tool_search_call
Yes tool_search_call

OpenAI.InputItemToolSearchOutputItemParam

Name Type Description Required Default
call_id string or null No
execution OpenAI.ToolSearchExecutionType No
id string or null No
status OpenAI.FunctionCallItemStatus or null No
tools array of OpenAI.Tool The loaded tool definitions returned by the tool search output. Yes
type enum The item type. Always tool_search_output.
Possible values: tool_search_output
Yes tool_search_output

OpenAI.InputItemType

Property Value
Type string
Values message
output_message
file_search_call
computer_call
computer_call_output
web_search_call
function_call
function_call_output
tool_search_call
tool_search_output
reasoning
compaction
image_generation_call
code_interpreter_call
local_shell_call
local_shell_call_output
shell_call
shell_call_output
apply_patch_call
apply_patch_call_output
mcp_list_tools
mcp_approval_request
mcp_approval_response
mcp_call
custom_tool_call_output
custom_tool_call
item_reference
tool_approval_response

OpenAI.InputItemWebSearchToolCall

Web search tool call

The results of a web search tool call.

Name Type Description Required Default
action OpenAI.WebSearchActionSearch or OpenAI.WebSearchActionOpenPage or OpenAI.WebSearchActionFind An object describing the specific action taken in this web search call.
Includes details on how the model used the web (search, open_page, find_in_page).
Yes
id string The unique ID of the web search tool call. Yes
status enum The status of the web search tool call.
Possible values: in_progress, searching, completed, failed
Yes
type enum The type of the web search tool call. Always web_search_call.
Possible values: web_search_call
Yes

OpenAI.InputMessageContentList

Input item content list

A list of one or many input items to the model, containing different content types.

Array of: OpenAI.InputContent

OpenAI.InputTextContentParam

Input text

A text input to the model.

Name Type Description Required Default
text string The text input to the model.
Constraints: maxLength: 10485760
Yes
type enum The type of the input item. Always input_text.
Possible values: input_text
Yes input_text

OpenAI.ItemReferenceParam

Item reference

An internal identifier for an item to reference.

Name Type Description Required Default
id string The ID of the item to reference. Yes
type enum The type of item to reference. Always item_reference.
Possible values: item_reference
Yes item_reference

OpenAI.KeyPressAction

KeyPress

A collection of keypresses the model would like to perform.

Name Type Description Required Default
keys array of string The combination of keys the model is requesting to be pressed. This is an array of strings, each representing a key. Yes
type enum Specifies the event type. For a keypress action, this property is always set to keypress.
Possible values: keypress
Yes keypress

OpenAI.LocalEnvironmentResource

Local Environment

Represents the use of a local environment to perform shell actions.

Name Type Description Required Default
type enum The environment type. Always local.
Possible values: local
Yes local

OpenAI.LocalShellExecAction

Local shell exec action

Execute a shell command on the server.

Name Type Description Required Default
command array of string The command to run. Yes
env object Environment variables to set for the command. Yes
timeout_ms integer or null No
type enum The type of the local shell action. Always exec.
Possible values: exec
Yes exec
user string or null No
working_directory string or null No

OpenAI.LocalShellToolParam

Local shell tool

A tool that allows the model to execute shell commands in a local environment.

Name Type Description Required Default
type enum The type of the local shell tool. Always local_shell.
Possible values: local_shell
Yes local_shell

OpenAI.LocalSkillParam

Name Type Description Required Default
description string The description of the skill. Yes
name string The name of the skill. Yes
path string The path to the directory containing the skill. Yes

OpenAI.LogProb

Log probability

The log probability of a token.

Name Type Description Required Default
bytes array of integer Yes
logprob number Yes
token string Yes
top_logprobs array of OpenAI.TopLogProb Yes

OpenAI.MCPListToolsTool

MCP list tools tool

A tool available on an MCP server.

Name Type Description Required Default
annotations OpenAI.MCPListToolsToolAnnotations or null No
description string or null No
input_schema OpenAI.MCPListToolsToolInputSchema Yes
name string The name of the tool. Yes

OpenAI.MCPListToolsToolAnnotations

Type: object

OpenAI.MCPListToolsToolInputSchema

Type: object

OpenAI.MCPTool

MCP tool

Give the model access to additional tools via remote Model Context Protocol (MCP) servers.

Name Type Description Required Default
allowed_tools array of string or OpenAI.MCPToolFilter or null No
authorization string An OAuth access token that can be used with a remote MCP server, either
with a custom MCP server URL or a service connector. Your application
must handle the OAuth authorization flow and provide the token here.
No
connector_id enum Identifier for service connectors, like those available in ChatGPT. One of
server_url or connector_id must be provided. Learn more about service
connectors here.
Currently supported connector_id values are:
- Dropbox: connector_dropbox
- Gmail: connector_gmail
- Google Calendar: connector_googlecalendar
- Google Drive: connector_googledrive
- Microsoft Teams: connector_microsoftteams
- Outlook Calendar: connector_outlookcalendar
- Outlook Email: connector_outlookemail
- SharePoint: connector_sharepoint
Possible values: connector_dropbox, connector_gmail, connector_googlecalendar, connector_googledrive, connector_microsoftteams, connector_outlookcalendar, connector_outlookemail, connector_sharepoint
No
defer_loading boolean Whether this MCP tool is deferred and discovered via tool search. No
headers object or null No
require_approval OpenAI.MCPToolRequireApproval or string or null No
server_description string Optional description of the MCP server, used to provide more context. No
server_label string A label for this MCP server, used to identify it in tool calls. Yes
server_url string (uri) The URL for the MCP server. One of server_url or connector_id must be
provided.
No
type enum The type of the MCP tool. Always mcp.
Possible values: mcp
Yes

OpenAI.MCPToolCallStatus

Property Value
Type string
Values in_progress
completed
incomplete
calling
failed

OpenAI.MCPToolFilter

MCP tool filter

A filter object to specify which tools are allowed.

Name Type Description Required Default
read_only boolean Indicates whether or not a tool modifies data or is read-only. If an
MCP server is annotated with readOnlyHint,
it will match this filter.
No
tool_names array of string List of allowed tool names. No

OpenAI.MCPToolRequireApproval

Name Type Description Required Default
always OpenAI.MCPToolFilter A filter object to specify which tools are allowed. No
never OpenAI.MCPToolFilter A filter object to specify which tools are allowed. No

OpenAI.MessageContent

A content part that makes up an input or output item.

Discriminator for OpenAI.MessageContent

This component uses the property type to discriminate between different types:

Type Value Schema
text OpenAI.TextContent
computer_screenshot OpenAI.ComputerScreenshotContent
input_text OpenAI.MessageContentInputTextContent
output_text OpenAI.MessageContentOutputTextContent
reasoning_text OpenAI.MessageContentReasoningTextContent
refusal OpenAI.MessageContentRefusalContent
input_image OpenAI.MessageContentInputImageContent
input_file OpenAI.MessageContentInputFileContent
summary_text OpenAI.SummaryTextContent
Name Type Description Required Default
type OpenAI.MessageContentType Yes

OpenAI.MessageContentInputFileContent

Input file

A file input to the model.

Name Type Description Required Default
detail OpenAI.FileInputDetail No
file_data string The content of the file to be sent to the model. No
file_id string or null No
file_url string (uri) The URL of the file to be sent to the model. No
filename string The name of the file to be sent to the model. No
type enum The type of the input item. Always input_file.
Possible values: input_file
Yes input_file

OpenAI.MessageContentInputImageContent

Input image

An image input to the model.

Name Type Description Required Default
detail OpenAI.ImageDetail Yes
file_id string or null No
image_url string or null No
type enum The type of the input item. Always input_image.
Possible values: input_image
Yes input_image

OpenAI.MessageContentInputTextContent

Input text

A text input to the model.

Name Type Description Required Default
text string The text input to the model. Yes
type enum The type of the input item. Always input_text.
Possible values: input_text
Yes input_text

OpenAI.MessageContentOutputTextContent

Output text

A text output from the model.

Name Type Description Required Default
annotations array of OpenAI.Annotation The annotations of the text output. Yes
logprobs array of OpenAI.LogProb Yes
text string The text output from the model. Yes
type enum The type of the output text. Always output_text.
Possible values: output_text
Yes output_text

OpenAI.MessageContentReasoningTextContent

Reasoning text

Reasoning text from the model.

Name Type Description Required Default
text string The reasoning text from the model. Yes
type enum The type of the reasoning text. Always reasoning_text.
Possible values: reasoning_text
Yes reasoning_text

OpenAI.MessageContentRefusalContent

Refusal

A refusal from the model.

Name Type Description Required Default
refusal string The refusal explanation from the model. Yes
type enum The type of the refusal. Always refusal.
Possible values: refusal
Yes refusal

OpenAI.MessageContentType

Property Value
Type string
Values input_text
output_text
text
summary_text
reasoning_text
refusal
input_image
computer_screenshot
input_file

OpenAI.MessagePhase

Labels an assistant message as intermediate commentary (commentary) or the final answer (final_answer). For models like gpt-5.3-codex and beyond, when sending follow-up requests, preserve and resend phase on all assistant messages — dropping it can degrade performance. Not used for user messages.

Property Value
Type string
Values commentary
final_answer

OpenAI.MessageRole

Property Value
Type string
Values unknown
user
assistant
system
critic
discriminator
developer
tool

OpenAI.MessageStatus

Property Value
Type string
Values in_progress
completed
incomplete

OpenAI.Metadata

Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard. Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.

Type: object

OpenAI.MoveParam

Move

A mouse move action.

Name Type Description Required Default
keys array of string or null No
type enum Specifies the event type. For a move action, this property is always set to move.
Possible values: move
Yes move
x integer The x-coordinate to move to. Yes
y integer The y-coordinate to move to. Yes

OpenAI.NamespaceToolParam

Namespace

Groups function/custom tools under a shared namespace.

Name Type Description Required Default
description string A description of the namespace shown to the model.
Constraints: minLength: 1
Yes
name string The namespace name used in tool calls (for example, crm).
Constraints: minLength: 1
Yes
tools array of OpenAI.FunctionToolParam or OpenAI.CustomToolParam The function/custom tools available inside this namespace.
Constraints: minItems: 1
Yes
type enum The type of the tool. Always namespace.
Possible values: namespace
Yes namespace

OpenAI.OutputMessageContent

Discriminator for OpenAI.OutputMessageContent

This component uses the property type to discriminate between different types:

Type Value Schema
output_text OpenAI.OutputMessageContentOutputTextContent
refusal OpenAI.OutputMessageContentRefusalContent
Name Type Description Required Default
type OpenAI.OutputMessageContentType Yes

OpenAI.OutputMessageContentOutputTextContent

Output text

A text output from the model.

Name Type Description Required Default
annotations array of OpenAI.Annotation The annotations of the text output. Yes
logprobs array of OpenAI.LogProb Yes
text string The text output from the model. Yes
type enum The type of the output text. Always output_text.
Possible values: output_text
Yes output_text

OpenAI.OutputMessageContentRefusalContent

Refusal

A refusal from the model.

Name Type Description Required Default
[...]
